#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xlocale.h>
main(argc, argv)
int argc;
char **argv;
{
   Display *d;             Window w;
   XFontSet fs;            GC gc;
   char **miss, *def;      XRectangle ink, log;
   int w_width, w_height, tx, ty, rx, ry, n_miss;

   setlocale (LC_ALL, "");
   d = XOpenDisplay (NULL);
   if (XSupportsLocale () == False) exit (1);

   w_width = 400; w_height = 200;
   w = XCreateSimpleWindow (d, RootWindow (d, 0), 400, 400,
                            w_width, w_height, 2, 0, 1);
   XMapWindow (d, w);
   gc = XCreateGC (d, w, 0, 0);

   fs = XCreateFontSet (d, argv[1], &miss, &n_miss, &def);
   XmbTextExtents (fs, argv[2], strlen (argv[2]), &ink, &log);

   rx = (w_width - log.width) / 2;
   ry = (w_height - log.height) / 2;
   XDrawRectangle (d, w, gc, rx, ry, log.width, log.height);

   tx = rx;  ty = ry - log.y;
   XmbDrawString (d, w, fs, gc, tx, ty, argv[2], strlen (argv[2]));

   XFlush (d);
   getchar ();
}
